function CreateDataGrid(rs) { return new DataGrid(rs); }
function DataGrid(RecordSet,writer)
{
	var rs = RecordSet;
	
	this.Writer = (writer)?writer:Response;
	this.DataSource = RecordSet;
	
/**************************************************
 * Column
 **************************************************/
	var Column = function(rs,i,writer,dg) {
		
		this.Writer = writer;

		/* Data Properties */
		this.HeadingText = rs.Fields(i).Name;
		this.GetValue = function () {return rs.Fields(i).Value;}
		
		/* Display Properties */
		this.Visible = true;
		this.Width = null;
		this.Style = null;
		this.Align= null;
		this.CssClass = dg.CssClass;
		
		/* Heading Display Properties */
		this.HeadingAlign = null;
		this.HeadingStyle = null;
		this.HeadingCssClass = null;
	
		/* Methods */
		this.Write = function(text) { this.Writer.Write(text); }
		
		this.WriteText = function() { this.Write(this.RenderText()); }		
		this.RenderText = function() {return this.GetValue();}

		this.WriteHeadingText = function() { this.Write(this.RenderHeadingText()); }
		this.RenderHeadingText = function() {return this.HeadingText;}
		
		this.WriteHeading = function() {this.Write(this.RenderHeading());}
		this.RenderHeading = function() {
			return '<th'
				+ ( (this.HeadingAlign!=null)?(' align="'+this.HeadingAlign+'"'):(''))
				+ ( (this.Width!=null)?(' width="'+this.Width+'"'):(''))
				+ ( (this.HeadingStyle!=null)?(' style="'+this.HeadingStyle+'"'):(''))
				+ '>' 
				+ this.RenderHeadingText() 
				+ '</th>';
		}
	}

/**************************************************
 * Display Properties of Grid 
 **************************************************/
	this.AlternatingBgColor='#eaeaea';
	this.BgColor='#ffffff';
	this.Width = null;
	this.Border = 0;
	this.CellPadding = 3;
	this.CellSpacing = 0;
	this.Style = null;
	this.CssClass = null;
	this.ShowHeadings=true;
		
/**************************************************
 * Columns
 **************************************************/
	this.Columns = Array();	
	for (var i=0;i<rs.Fields.Count;i++)
	{
		this.Columns[i] = new Column(rs,i,this.Writer,this);
		this.Columns[rs.Fields(i).Name]=this.Columns[i];
	}
	
	
/**************************************************
 * Output Methods
 **************************************************/	
 	this.Display = function()
	{
		this.WriteTableOpen();
		if (this.ShowHeadings) this.WriteColumnHeadings();
		this.WriteRows();
		this.WriteTableClose();
	}
	
	this.Write = function(t) {this.Writer.Write(t);}
	
	this.WriteTableOpen = function() {this.Write(this.RenderTableOpen());}
	this.RenderTableOpen = function() {
		return '<table'
			+ ((this.CellPadding!=null)?(' cellpadding="'+this.CellPadding+'"'):(''))
			+ ((this.CellSpacing!=null)?(' cellspacing="'+this.CellSpacing+'"'):(''))
			+ ((this.Border!=null)?(' border="'+this.Border+'"'):(''))
			+ ((this.Width!=null)?(' width="'+this.Width+'"'):(''))
			+ '>';
	}
	
	this.WriteTableClose = function() {this.Write(this.RenderTableClose());}
	this.RenderTableClose = function() {return '</table>';}
	
	this.WriteColumnHeadings = function() {
		this.Write('<tr>');
		for (var i=0;i<this.Columns.length;i++) this.WriteColumnHeading(this.Columns[i]);
		this.Write('</tr>');
	}
	this.WriteColumnHeading= function(col) {if (col.Visible) col.WriteHeading();}


	this.WriteRows = function() {while (!rs.EOF) {this.WriteRow();rs.MoveNext();}}

	this.IsAlternatingRow = false; //helper
	this.WriteRow = function() {
		this.Write('<tr');
		this.Write(' bgcolor="' + (this.IsAlternatingRow?this.AlternatingBgColor:this.BgColor) + '"');
		this.Write('>');
		for (var i=0;i<this.Columns.length;i++) this.WriteCell(this.Columns[i]);
		this.Write('</tr>');
		this.IsAlternatingRow = !this.IsAlternatingRow;
	}

	this.WriteCell = function(col) {
		if (col.Visible) {
			this.Write('<td');
			if (col.Width) this.Write(' width="'+col.Width+'"');
			if (col.Style) this.Write(' style="'+col.Style+'"');
			if (col.Align) this.Write(' align="'+col.Align+'"');				
			if (col.CssClass) this.Write(' class="'+col.CssClass+'"');				
			this.Write('>');
			col.WriteText();
			this.Write('</td>');
		}
	}
	
}